{This is the source code of the tool TORPAcyc for proving termination of cycle rewriting,
developed by Hans Zantema in 2013 - 2015. 
It calls the SMT solver yices, from http://yices.csl.sri.com/
and uses the file param containing some parameters

The first line of the file param contains the location of the tool yices, the other
lines contain bounds on dimensions and flags for using match-bounds and verbose
option.

Comments are welcome on h.zantema@tue.nl
}

program torpa(input,output,rr);
uses GPC;

const maxrule = 1000; maxnaam = 100; maxlen = 50; 

var
rr : text;
  l,lw,r,rw,lbu,rbu : array[1..maxrule,1..maxlen] of byte;
  stappen,hib,whib,naamhib,nwhib,hibbu : integer;
  naam,naamw : array[1..maxnaam] of string;
  c,path : string;
  i,j,k,mxr,mpdim,trdim,ardim : integer;
  trop,mp,verbose,mb : boolean;

function inttostr(i : integer): string;
var n : integer; s : string;
procedure schr(j : integer);
begin
if j = 0 then s := s + '0';
if j = 1 then s := s + '1';
if j = 2 then s := s + '2';
if j = 3 then s := s + '3';
if j = 4 then s := s + '4';
if j = 5 then s := s + '5';
if j = 6 then s := s + '6';
if j = 7 then s := s + '7';
if j = 8 then s := s + '8';
if j = 9 then s := s + '9';
end;
begin
s := '';
n := i;
if n > 99 then begin schr(n div 100); n := n mod 100; end;
if (s <> '') or ((n div 10) > 0) then schr(n div 10);
schr(n mod 10);
inttostr := s;
end;

procedure srstow;
begin
lw := l; rw := r; whib := hib; 
naamw := naam; nwhib := naamhib;
end;

function schrijfregel(i:integer):string;
var s : string; j : integer;
begin
s := '';
j := 1;
while l[i,j] <> 0 do begin s := s+naam[l[i,j]]+' '; j := j+1 end;
s := s + ' -> ';
j := 1;
while r[i,j] <> 0 do begin s := s+naam[r[i,j]]+' '; j := j+1 end;
schrijfregel := s;
if j = 1 then s := s + 'e';
end;



procedure matchb;
var le,buur,goal,sym,lab : array[1..1000] of integer;
mb, i, j, ehib, ehibbu, nhib, lijsthib, rulenr,startnode, maxe : integer;
lijst : array[1..500,1..maxlen] of integer;
templijst : array[1..maxlen] of integer;
ovflow : boolean;

procedure maaklijst(node,symnr: integer);
{maakt lijst van alle manieren om lw[rulenr] te doorlopen}
var edge,i: integer;
begin
if lw[rulenr,symnr] = 0 then
begin
lijsthib := lijsthib + 1;
if lijsthib >500 then ovflow := true else
begin
for i := 1 to symnr do lijst[lijsthib,i] := templijst[i];
lijst[lijsthib,symnr] := 0;
end
end else
begin
edge := le[node];
while edge > 0 do
if sym[edge] = lw[rulenr,symnr] then
begin
templijst[symnr] := edge;
maaklijst(goal[edge],symnr+1);
edge := buur[edge];
end else edge := buur[edge];
end;
end; {maaklijst}

procedure maakpad(lijsti:integer);
var minl,endnode,i, maxok,bestj,j,innode, e, snode : integer;

procedure zoek(j,node:integer);
{ zoeknode(j,n) wordt alleen aangeroepen als er een goed pad is
van startnode naar n van lengte j-startj}
var edge: integer;
begin
if j > maxok then begin maxok := j; innode := node; end;
if rw[rulenr,j] > 0 then
begin
edge := le[node];
while edge > 0 do
begin
if (sym[edge] = rw[rulenr,j]) and (lab[edge] = minl) then
if (rw[rulenr,j+1] > 0) or (goal[edge] = endnode) then
zoek(j+1,goal[edge]);
edge := buur[edge];
end;
end;
end; {zoek}

begin {maakpad}
minl := 1000;
snode := startnode;
i := 1;
while lijst[lijsti,i] > 0 do
begin
if lab[lijst[lijsti,i]] < minl then minl := lab[lijst[lijsti,i]];
endnode := goal[lijst[lijsti,i]];
i := i+1;
end;
minl := minl + 1;
if minl > mb then mb := minl;
maxok := 0;
zoek(1,startnode);
if rw[rulenr,maxok] > 0 then
  begin
  bestj := 0;
  if rw[rulenr,2] > 0 then
  for j := 1 to nhib do
    begin
    maxok := 0;
    zoek(2,j);
    if rw[rulenr,maxok] = 0 then bestj := j;
    end;
  if bestj = 0 then
    {maak pad van startnode naar endnode}
begin
maxok := 1;
if rw[rulenr,maxok+1] > 0 then
begin
e := le[startnode];
while (e > 0) and not((sym[e] = rw[rulenr,1]) and (lab[e] = minl)) do e := buur[e];
if e > 0 then
begin
snode := goal[e];
maxok := maxok+1;
end;
end;

e := le[snode];
while buur[e] > 0 do e := buur[e];
ehib := ehib + 1;
if ehib > maxe then ovflow := true;
buur[e] := ehib;
e := ehib;
buur[e] := 0;
lab[e] := minl;
sym[e] := rw[rulenr,maxok];

while rw[rulenr,maxok+1] > 0 do
begin
maxok := maxok + 1;
nhib := nhib + 1;
goal[e] := nhib;
ehib := ehib +1;
e := ehib;
le[nhib] := e;
buur[e] := 0;
lab[e] := minl;
sym[e] := rw[rulenr,maxok];
end;
goal[e] := endnode
end else {maak edge van snode naar bestj}
    begin
e := le[snode];
while buur[e] > 0 do e := buur[e];
ehib := ehib + 1;
if ehib > maxe then ovflow := true;
buur[e] := ehib;
e := ehib;
buur[e] := 0;
lab[e] := minl;
sym[e] := rw[rulenr,1];
goal[e] := bestj;
    end;
  end;
end; {maakpad}


begin {matchb}
srstow;
ovflow := false;
mb := 0;
{initrfc;
versie voor Sigma* ipv RFC}
nhib := 1;
ehib := nwhib;
le[1] := 1;
for i := 1 to nwhib do
begin
if i < nwhib then buur[i] := i+1 else buur[i] := 0;
goal[i] := 1;
sym[i] := i;
lab[i] := 0;
end;

maxe := 900; {was 800}
ehibbu := 0;
while (not ovflow) and (ehibbu < ehib) do
begin
ehibbu := ehib;
for rulenr := 1 to whib do
for startnode := nhib downto 1 do
begin
lijsthib := 0;
maaklijst(startnode,1);
for i := 1 to lijsthib do
if not ovflow then maakpad(i);
end;
end;
if not ovflow then
begin
rewrite(rr);
reset(rr);
writeln(rr,'YES');
close(rr);
i := Execute('mv frm srs');
hib := 0;
writeln('');
writeln('Terminating due to match bound '+inttostr(mb)+',');
writeln('proved by the graph consisting of the following edges:');
for j := 1 to nhib do
begin
i := le[j];
while i > 0 do
begin
writeln('from '+inttostr(j)+' to '+inttostr(goal[i])+
', label: '+naamw[sym[i]]+inttostr(lab[i]));
i := buur[i];
end;
end;
end else
if verbose then
writeln('No graph found until match bound '+inttostr(mb)+'.');
end; {matchb}




procedure typgr(n : integer);
var rulenr,i,j,len,nhib,ll,mx : integer;
bb : array[1..maxrule] of integer;
decr : array[1..maxrule] of boolean;
s : string;

procedure mul(a,b,c:integer);
var i,j,k : integer;
begin
for i := 1 to n do
for j := 1 to n do
if mp then 
begin
writeln(rr,' (= (A ',c,' ',i,' ',j,') (+ ');
for k := 1 to n do
begin
writeln(rr,'(ite (B ',b,' ',k,' ',j,' 0) (A ',a,' ',i,' ',k,') 0)');
writeln(rr,'(ite (B ',b,' ',k,' ',j,' 1) (* 2 (A ',a,' ',i,' ',k,')) 0)');
writeln(rr,'(ite (B ',b,' ',k,' ',j,' 2) (* 4 (A ',a,' ',i,' ',k,')) 0)');
end;
writeln(rr,'))');
end else
begin
writeln(rr,'(or');
for k := 1 to n do
begin
write(rr,'(and (= (A ',c,' ',i,' ',j,') (+ (A ',a,' ',i,' ',k,') (A ',b,' ',k,' ',j,')))');
write(rr,' (not (I ',c,' ',i,' ',j,')) (not (I ',a,' ',i,' ',k,')) (not (I ',b,' ',k,' ',j,')))'); 
write(rr,' (and (I ',c,' ',i,' ',j,') (I ',a,' ',i,' ',k,'))'); 
writeln(rr,' (and (I ',c,' ',i,' ',j,') (I ',b,' ',k,' ',j,'))'); 
end;
writeln(rr,')');
for k := 1 to n do
begin
if trop then
write(rr,'(or (and (not (I ',c,' ',i,' ',j,')) (not (I ',a,' ',i,' ',k,')) (not (I ',b,' ',k,' ',j,'))
(<= (A ',c ,' ',i,' ',j,') (+ (A ',a,' ',i,' ',k,') (A ',b,' ',k,' ',j,'))))') else
write(rr,'(or (and (not (I ',c,' ',i,' ',j,')) (not (I ',a,' ',i,' ',k,')) (not (I ',b,' ',k,' ',j,'))
(>= (A ',c ,' ',i,' ',j,') (+ (A ',a,' ',i,' ',k,') (A ',b,' ',k,' ',j,'))))');
writeln(rr,' (I ',a,' ',i,' ',k,') (I ',b,' ',k,' ',j,'))'); 
end;
end;
end; {mul}

procedure gr(a,b:integer);
var i,j : integer;
begin
writeln(rr,'; rule ',rulenr);
if mp then
writeln(rr,'(iff (D ',rulenr,') (> (A ',a,' 1 1)  (A ',b,' 1 1)))'); 
for i := 1 to n do
for j := 1 to n do
begin
if mp then
writeln(rr,'(>= (A ',a,' ', i,' ',j,')  (A ',b,' ',i,' ',j,'))') else
begin
if trop then
writeln(rr,'(or (not (D ',rulenr,')) (I ',a,' ',i,' ',j,') (and (not (I ',a,' ',i,' ',j,')) (not (I ',b,' ',i,' ',j,')) (> (A
',a,' ', i,' ',j,')  (A ',b,' ',i,' ',j,'))))') else
writeln(rr,'(or (not (D ',rulenr,')) (I ',b,' ',i,' ',j,') (and (not (I ',a,' ',i,' ',j,')) (not (I ',b,' ',i,' ',j,')) (> (A
',a,' ', i,' ',j,')  (A ',b,' ',i,' ',j,'))))');
if trop then
writeln(rr,'(or (D ',rulenr,') (I ',a,' ',i,' ',j,') (and (not (I ',a,' ',i,' ',j,')) (not (I ',b,' ',i,' ',j,')) (>= (A
',a,' ', i,' ',j,')  (A ',b,' ',i,' ',j,'))))') else
writeln(rr,'(or (D ',rulenr,') (I ',b,' ',i,' ',j,') (and (not (I ',a,' ',i,' ',j,')) (not (I ',b,' ',i,' ',j,')) (>= (A
',a,' ', i,' ',j,')  (A ',b,' ',i,' ',j,'))))');
end;
end;
end; {gr}

procedure find;
var a : array[1..10000,1..5,1..5] of integer;
c : char; ss : string;
i,j,k,q : integer;
begin
for i := 1 to n do 
for j := 1 to n do 
for k := 1 to naamhib do a[k,i,j] := 0;
readln(rr,s);
readln(rr,s);
while length(s) > 5  do
begin
ss := '';
for i := 2 to length(s) do ss := ss+s[i];
s := ss;
if s[5] in ['A','B','D','I'] then
begin
q := 0;
k := ord(s[7]) - ord('0');
if s[8] <> ' ' then
if s[8] <> ')' then
begin
q := 1;
k := 10*k + ord(s[8]) - ord('0');
if s[9] <> ' ' then
if s[9] <> ')' then
begin
q := 2;
k := 10*k + ord(s[9]) - ord('0');
end;
end;
if s[5] = 'D' then 
begin if s[10+q] = 't' then decr[k] := true else decr[k] := false; end
else begin
i := ord(s[9+q]) - ord('0');
j := ord(s[11+q]) - ord('0');
if s[5] = 'I' then 
begin if s[14+q] = 't' then a[k,i,j] := -1; end
else
if s[5] = 'A' then 
begin
if a[k,i,j] > -1 then 
begin
a[k,i,j] := ord(s[14+q]) - ord('0');
if s[15+q] <> ')' then a[k,i,j] := 10*a[k,i,j] + ord(s[15+q]) - ord('0');
end;
end else 
if not(s[5] = 'B') then 
writeln('ERROR');
end;
end;
if not eof(rr) then readln(rr,s) else s := '';
end;
if n > 1 then 
if mp then writeln('Normal matrix interpretation') else
if trop then writeln('Tropical matrix interpretation')
else writeln('Arctic matrix interpretation');
for k := 1 to naamhib do
begin
if n = 1 then 
writeln('interpretation of ',naam[k],': ',a[k,1,1])
else begin
writeln('interpretation of ',naam[k],':');
for i := 1 to n do
begin
if n > 1 then
if i = 1 then write('/') else
if i = n then write('\') else write('|');
for j := 1 to n do
if a[k,i,j] = -1 then write(' -') else write(' ',a[k,i,j]);
if n > 1 then
if i = 1 then write(' \') else
if i = n then write(' /') else write(' |');
writeln;
end;
end;
end;
k := 0;
for i := 1 to hib do
if decr[i] then writeln('remove rule ',i) else
begin 
k := k+1;
l[k] := l[i];
r[k] := r[i];
end;
hib :=k;
if hib = 0 then 
begin
writeln('termination has been proved');
rewrite(rr);
reset(rr);
writeln(rr,'YES');
close(rr);
i := Execute('mv frm srs');
end;
end;
begin {typgr}
rewrite(rr);
reset(rr);
if n = 1 then mx := 10 else mx := mxr;

writeln(rr,'(benchmark test.smt');
writeln(rr,':logic QF_UFLIA');
writeln(rr,':extrafuns ((A Int Int Int Int))');
writeln(rr,':extrapreds ((D Int))');
if mp then writeln(rr,':extrapreds ((B Int Int Int Int))')
else writeln(rr,':extrapreds ((I Int Int Int))');
writeln(rr,':formula (and');
writeln(rr,'(or');
for i := 1 to hib do 
writeln(rr,'(D ',i,')');
writeln(rr,')');

for i := 1 to naamhib do
if mp then
writeln(rr,'(< 0 (A ',i,' 1 1))')
else writeln(rr,'(not (I ',i,' 1 1))');
if mp then 
for i := 1 to naamhib do
for j := 1 to n do
for k := 1 to n do
writeln(rr,'(= (A ',i,' ',j,' ',k,') (+ (ite (B ',i,' ',j,' ',k,' 0) 1 0 ) (ite (B ',i,' ',j,' ',k,' 1) 2 0) (ite (B ',i,' ',j,' ',k,' 2) 4 0)))');
for i := 1 to naamhib do
for j := 1 to n do
for k := 1 to n do
writeln(rr,'(<= 0 (A ',i,' ',j,' ',k,'))');
if mx > 0 then
for i := 1 to naamhib do
for j := 1 to n do
for k := 1 to n do
writeln(rr,'(>= ',mx,' (A ',i,' ',j,' ',k,'))');
nhib := naamhib;
for rulenr := 1 to hib do 
begin
len := 1;
while l[rulenr,len] > 0 do len := len + 1;
len := len -1;
if len > 1 then 
for i:= 2 to len do 
  begin
  nhib := nhib+1;
  if i = 2 then mul(l[rulenr,1],l[rulenr,i],nhib) else
  mul(nhib-1,l[rulenr,i],nhib);
  end;
if len = 1 then ll :=  l[rulenr,1] else ll := nhib;
len := 1;
while r[rulenr,len] > 0 do len := len + 1;
len := len -1;
if len > 1 then 
for i:= 2 to len do 
  begin
  nhib := nhib+1;
  if i = 2 then mul(r[rulenr,1],r[rulenr,i],nhib) else
  mul(nhib-1,r[rulenr,i],nhib);
  end;
if len = 0 then
  begin
  nhib := nhib+1;
  if mp then 
  for i := 1 to n do
  for j := 1 to n do
  if i = j then writeln(rr,' (= 1 (A ',nhib,' ',i,' ',j,'))')
    else writeln(rr,' (= 0 (A ',nhib,' ',i,' ',j,'))')
  else 
  for i := 1 to n do
  for j := 1 to n do
  if i = j then writeln(rr,' (= 0 (A ',nhib,' ',i,' ',j,')) (not (I ',nhib,' ',i,' ',j,'))')
    else writeln(rr,' (I ',nhib,' ',i,' ',j,')');
  end;
if len = 1 then gr(ll,r[rulenr,1]) else gr(ll,nhib);
end;
writeln(rr,'))');
close(rr);
{i := Execute('../../../d.sat/yices/yices -e -smt frm > r');}
{i := Execute(path+' -e -smt frm > r');}
i := Execute(path+' -m frm > r');
i := Execute('cp r frm');
reset(rr);
readln(rr,s);
if s = 'unsat' then 
begin
if verbose then
writeln('attempt failed for dimension ',n);
end else find;
close(rr);
end;


function nr(c : string) : integer;
var i,r : integer;
begin
i := 0;
while i < naamhib do
begin
i := i + 1;
if naam[i] = c then begin r := i; i := naamhib + 1 end;
end;
if i = naamhib then
begin
naamhib := naamhib + 1;
naam[naamhib] := c;
r := naamhib;
end;
nr := r;
end;


{procedure lees;
var c : char; j,t : integer; s : string;
begin
naamhib := 0;
hib := 0;
readln(s);
if length(s) > 0 then
begin
while (length(s) > 0) and (s[1] <> ' ') do
begin
hib := hib + 1;
t := 0;
j := 1;
c := s[j];
while not( c in [' ','-','>','=']) do
begin
t := t + 1;
l[hib,t] := nr(c);
j := j+1;
c := s[j];
end;
l[hib,t+1] := 0;
while (c in [' ','-','>']) do
begin
j := j+1;
c := s[j];
end;
t := 0;
while not( c in [' ','e']) do
begin
t := t + 1;
r[hib,t] := nr(c);
j := j+1;
if j > length(s) then c := ' ' else
c := s[j];
end;
r[hib,t+1] := 0;
readln(s);
end;
srstow;
writeln('TORPAcyc is applied to the string rewriting system');
for j := 1 to whib do writeln(schrijfregel(j));
end;
end;
}


procedure lees;
var c : char; symt,j,t : integer; s,nm : string;
function nextsym : char;
begin
if symt < length(s) then symt := symt + 1 else
begin readln(s); symt := 1; end;
nextsym := s[symt];
if length(s) = 0 then nextsym := ' ';
end; {nextsym}
procedure leesnaam;
begin
c := nextsym;
while c = ' ' do c := nextsym;
if not(c in [',','-',')']) then
begin
nm := c;
c := nextsym;
while not(c in [' ',',','-',')'])  do 
begin nm := nm + c; c := nextsym end;
if c <> ' ' then begin c := ' '; symt := symt -1 end;
end;
end; {leesnaam}
 
begin {lees}
readln(s); symt := 0;
naamhib := 0;
hib := 0;
while nextsym <> 'S' do;
c := ' ';
while c <> ')' do
begin
leesnaam;
if not (c in [',',')']) then
begin
hib := hib + 1;
t := 0;
while c <> '-' do
begin
t := t + 1;
l[hib,t] := nr(nm);
leesnaam;
end;
c := nextsym;
c := nextsym;
l[hib,t+1] := 0;
t := 0;
if not(c in [',',')']) then leesnaam;
while not(c in [',',')']) do
begin
t := t + 1;
r[hib,t] := nr(nm);
leesnaam;
end;
r[hib,t+1] := 0;
end;
end;

srstow;
writeln('TORPAcyc is applied to the string rewriting system');
for j := 1 to hib do writeln(schrijfregel(j));
end; {lees}


{main program}
begin
assign(rr,'frm');
i := Execute('cp param frm');
reset(rr);
readln(rr,path);
readln(rr,i);
if i=1 then verbose := true else verbose := false;
readln(rr,mxr);
readln(rr,trdim);
readln(rr,ardim);
readln(rr,i);
if i=1 then mb := true else mb := false;
readln(rr,mpdim);
close(rr);
lees;
rewrite(rr);
reset(rr);
writeln(rr,'(RULES');
for j := 1 to hib do 
if j < hib then writeln(rr,schrijfregel(j)+' ,')
else writeln(rr,schrijfregel(j)+' )');
close(rr);
i := Execute('mv frm srs');
hibbu := 0;
while hib > 0 do 
begin
if hibbu >0 then 
begin 
rewrite(rr);
reset(rr);
writeln(rr,'(RULES');
for j := 1 to hib do 
if j < hib then writeln(rr,schrijfregel(j)+' ,')
else writeln(rr,schrijfregel(j)+' )');
close(rr);
i := Execute('mv frm srs');
writeln('continue with:');
for j := 1 to hib do writeln(schrijfregel(j));
end;
hibbu := hib;
mp := false;
trop := true;
typgr(1);
if trdim >= 2 then
if hibbu = hib then
typgr(2);
trop := false;
if ardim >= 2 then
if hibbu = hib then
typgr(2);
mp := true;
if mpdim >= 2 then
if hibbu = hib then
typgr(2);
if mb then
if hibbu = hib then 
begin
j := 1;
for i := 1 to hib do if r[i,1] = 0 then j := 0;
if j > 0 then matchb;
end;
mp := false;
trop := true;
if trdim >= 3 then
if hibbu = hib then
typgr(3);
trop := false;
if ardim >= 3 then
if hibbu = hib then
typgr(3);
mp := true;
if mpdim >= 3 then
if hibbu = hib then
typgr(3);
if hibbu = hib then
begin writeln('no proof found'); hib := 0; end;
end;
end.
